/***************************************************************************/
/*                Библиотека всяких полезных разностей                     */
/*  Анисимов Д.В.                                     28 октября 1996 г.   */
/***************************************************************************/
# ifndef MY_LIB
# define MY_LIB
# include <stdio.h>
# include <malloc.h>
# include <string.h>

# define Err_Memory   -1
# define Err_Fopen    -2
# define Err_Fread    -3
# define Err_Fwrite   -4
# define Err_Fseek    -5
# define Err_Data     -6
# define Err_Internal 100

/* ----------------------------- класс строк ----------------------------- */
typedef class t_String
{  char *s ;
   short j,n ;
public :
	    t_String( void );
	    t_String( char * );
	   ~t_String( void );
		operator char*( void );
       void     operator= ( t_String &A );
       void     operator= ( char *c );
       void     setlen( long N );
       void     operator+=( char c );
       void     operator+=( char *s );
       void     operator+=( t_String &A );
friend t_String operator+ ( t_String &A, char c );
friend t_String operator+ ( char c, t_String &A );
friend t_String operator+ ( t_String &A, char *s );
friend t_String operator+ ( char *s, t_String &B );
friend t_String operator+ ( t_String &A,t_String &B );
friend int      operator==( t_String &A, t_String &B );
friend int      operator!=( t_String &A, t_String &B );
friend int      operator> ( t_String &A, t_String &B );
friend int      operator< ( t_String &A, t_String &B );
       void     mysprintf(  char *format,... );
       void     radd( char c, short n );
} t_String ;

/* ----------- мои функции для работы с памятью и файлами ---------------- */
void *Malloc( long N );
void *Calloc( long N,long S );
void *Realloc( void *v,long L );

# define Free( v )    if( v!=NULL ){  free(v)  ; v=NULL;  }
# define Fclose( v )  if( v!=NULL ){  fclose(v) ; v=NULL;  }
# define DELETE( A )  if( A!=NULL ){  delete(A); A=NULL;  }


FILE *Fopen( char *Name, char *Schalter );
void  Fwrite( void *v, size_t s, size_t n, FILE *fw );
void  Fread( void *v, size_t s, size_t n, FILE *fr );
void  Fread1( void **v, size_t s, size_t n, FILE *fr );
long  FileLength( FILE *fw );

typedef class t_File
{  char     *Name ;
   FILE     *File ;
public:
	 t_File( void );
	~t_File( void );
   void  Fopen( char *Name, char *Schalter );
   void  Fwrite( void *v, size_t s, size_t n );
   void  Fread( void *v, size_t s, size_t n );
   void  Fseek( long Pos, int Mode );
} t_File ;

# endif

